//
// Bl.java: Simple Billard Game
// 	JDK 1.1 version
//				ů
//
//	ΥץϡJDK 1.1 ١ǽ񤫤ƤΤǡ
//	Ť֥饦Ǥϡưޤ
//
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;

//
// Applet main
//
public class Bl extends Applet {
    static final int playerLabelX	= 80 ;
    static final int playerLabelWidth	= 80 ;
    static final int playerLabelHeight	= 32 ;
    static final int scoreLabelWidth	= 60 ;
    static final int scoreLabelHeight	= 32 ;
    static final int playerMargin	=  2 ;

    static final int energyBarX		= 380 ;
    static final int cuePointerX	= 480 ;
    static final int toolLabelOffset	= 104 ;		

    BlOuterBoard outer_board ;
    BlInnerBoard inner_board ;
    Panel 	 playerPanel ;
    EnergyBar    ebar ;
    CuePointer   cuep ;
    Label[]      playerInfo ;
    Label[]	 scoreInfo ;
    int		 toolY ;

    public Bl () {
    }
    public void init () {
	Insets ins ;
	
	int iboardW = GameParam.BOARD_UNIT * 8 ;
	int iboardH = GameParam.BOARD_UNIT * 4 ; 
	int oboardW = iboardW + GameParam.BOARD_OUTER_MARGIN * 2 ;
	int oboardH = iboardH + GameParam.BOARD_OUTER_MARGIN * 2 ;

	//
	// Layout Game board, EnergyBar, CuePointer etc.
	//
	setBackground (Color.white) ;
	// ݡͥȤΥ֤ȼ˷Τǡ
	// LayoutManager  null ˤ롣
	setLayout (null) ;
	setSize (oboardW + 20, oboardH + 200) ;

	// ȤȤʤѥͥ
	outer_board = new BlOuterBoard (oboardW, oboardH,
					GameParam.BOARD_OUTER_MARGIN,
					GameParam.BOARD_UNIT) ;
	// ʡܡ...ǥबԤ
	inner_board = new BlInnerBoard (iboardW, iboardH,
					GameParam.BOARD_UNIT) ;
	inner_board.setLocation (GameParam.BOARD_OUTER_MARGIN,
				 GameParam.BOARD_OUTER_MARGIN) ;
	inner_board.setVisible (true) ;

	outer_board.setLocation (0, 0) ;
	outer_board.add (inner_board) ;
	outer_board.setVisible (true) ;
	add (outer_board) ;

	toolY = oboardH + 20 ;
	//
	// ͥ륮С
	//
	ebar = new EnergyBar (40, 100) ;
	ebar.setMax (100.0) ;
	ebar.setMin (0.0) ;
	ebar.setValue (50.0) ;
	ebar.setLocation (energyBarX, toolY) ;
	ebar.setVisible (true) ;
	add (ebar) ;
	// ͥ륮СΥ٥
	Label l ;
	l = new Label ("Energy", Label.CENTER)  ;
	l.setSize (100, 20) ;
	l.setLocation (energyBarX - 30, toolY + toolLabelOffset) ;
	add (l) ;

	int pl1y = toolY + 2 ;
	//
	// 塼ݥ
	//
	cuep = new CuePointer (100) ;
	cuep.setLocation (cuePointerX, toolY) ;
	cuep.setVisible (true) ;
	add (cuep) ;
	// Υ٥
	l = new Label ("Cueing Point", Label.CENTER)  ;
	l.setSize (140, 20) ;
	l.setLocation (cuePointerX - 20, toolY + toolLabelOffset) ;
	add (l) ;

	int labelOffset = 2 ;
	//
	// ץ쥤䡼ɽѤΥѥͥ
	//
	playerPanel = new Panel () ;
	playerPanel.setLayout (null) ;
	playerPanel.setLocation (playerLabelX, toolY) ;
	playerPanel.setSize (playerLabelWidth + scoreLabelWidth + 2 * labelOffset,
			     playerLabelHeight * 2 + playerMargin + 2 * labelOffset) ;
	playerPanel.setBackground (Color.black) ;
	playerPanel.setVisible (true) ;
	add (playerPanel) ;

	playerInfo = new Label[2] ;
	scoreInfo  = new Label[2] ;
	playerInfo[0] = new Label ("player1") ;

	playerInfo[0].setLocation (labelOffset, labelOffset) ;
	playerInfo[0].setSize     (playerLabelWidth, playerLabelHeight) ;
	playerInfo[0].setBackground (Color.orange) ;
	playerPanel.add (playerInfo[0]) ;

	scoreInfo[0] = new Label("0", Label.RIGHT) ;
	scoreInfo[0].setLocation (labelOffset + playerLabelWidth, labelOffset) ;
	scoreInfo[0].setSize (scoreLabelWidth, scoreLabelHeight) ;
	scoreInfo[0].setBackground (Color.orange) ;
	playerPanel.add (scoreInfo[0]) ;

	int pl2y = labelOffset + playerLabelHeight + playerMargin ;

	playerInfo[1] = new Label ("player2") ;
	playerInfo[1].setLocation (labelOffset, pl2y) ;
	playerInfo[1].setSize (playerLabelWidth, playerLabelHeight) ;
	playerInfo[1].setBackground (Color.white) ;
	playerPanel.add (playerInfo[1]) ;

	scoreInfo[1] = new Label("0", Label.RIGHT) ;
	scoreInfo[1].setLocation (labelOffset + playerLabelWidth, pl2y) ;
	scoreInfo[1].setSize (scoreLabelWidth, scoreLabelHeight) ;
	scoreInfo[1].setBackground (Color.white) ;
	playerPanel.add (scoreInfo[1]) ;

	//
	// ʡܡɤˡͥ륮С塼ݥ
	// ץ쥤䡼Τ餻
	//
	inner_board.notifyEnergyBar  (ebar) ;
	inner_board.notifyCuePointer (cuep) ;
	inner_board.notifyLabel      (playerInfo, scoreInfo) ;

    }
    // Application start point
    public static void main (String args[]) {
	AppletFrame.startApplet ("Bl", "Billiard", args) ;
    }
}

