//
// EnergyBar.java: ͥ륮С
// 	JDK 1.1 version
//				ů
//	ΥץϡJDK 1.1 ١ǽ񤫤ƤΤǡ
//	Ť֥饦Ǥϡưޤ
//
import java.awt.* ;
import java.awt.event.*;

public class EnergyBar extends Component
	implements MouseListener, MouseMotionListener
{
    static final int border = 4 ;
    double maxvalue ;
    double minvalue ;
    double value ;
    int    inWidth ;
    int	   inHeight ;
    int	   pointerY ;
    
    public EnergyBar (int width, int height) {
	super() ;
	
	setSize (width, height) ;
	maxvalue = 100.0 ;
	minvalue = 0.0 ;
	value = 50.0 ;

	inWidth  = width  - border * 2 ;
	inHeight = height - border * 2 ;
	setBackground (Color.black) ;
	addMouseListener (this) ;
	addMouseMotionListener (this) ;
    }
    public void setMax (double value) {
	maxvalue = value ;
	repaint () ;
    }
    public double getMax () {
	return maxvalue ;
    }
    public void setMin (double value) {
	minvalue = value ;
	repaint () ;
    }
    public double getMin () {
	return minvalue ;
    }
    public void setValue (double value) {
	value = value ;
	repaint () ;
    }
    public double getValue () {
	return value ;
    }
    public void paint (Graphics g) {
	int valuey ;
	Dimension s ;

	s = getSize () ;
	g.setColor (Color.black) ;
	g.fillRect (0, 0, s.width, s.height) ;

	valuey = (int)(inHeight - value / (maxvalue - minvalue) * (double)inHeight) + border ;
	if (valuey < border)
	    valuey = border ;
	if (valuey > border + inHeight)
	    valuey = border + inHeight ;
	g.setColor (Color.white) ;
	g.fillRect (border, border, inWidth, valuey - border) ;
	g.setColor (Color.blue) ;
	g.fillRect (border, valuey, inWidth, border + inHeight - valuey) ;
    }
    public void mouseClicked (MouseEvent e) {
    }
    public void mouseEntered (MouseEvent e) {
    }
    public void mouseExited (MouseEvent e) {
    }
    public void mousePressed (MouseEvent e) {
	int y = e.getY() ;
	Graphics g ;

	if (y < border)
	    y = border ;
	if (y > border + inHeight)
	    y = border + inHeight ;
	g = getGraphics () ;
	g.setColor (Color.white) ;
	g.fillRect (border, border, inWidth, y - border) ;
	g.setColor (Color.blue) ;
	g.fillRect (border, y, inWidth, border + inHeight - y) ;
	pointerY = y ; 
    }
    public void mouseReleased (MouseEvent e) {
    }
    public void mouseDragged (MouseEvent e) {
	int y = e.getY() ;
	Graphics g = getGraphics() ;

	if (y < border)
	    y = border ;
	if (y > border + inHeight)
	    y = border + inHeight ;
	if (y > pointerY) {
	    g.setColor (Color.white) ;
	    g.fillRect (border, pointerY, inWidth, y - pointerY) ;
	} else {
	    g.setColor (Color.blue) ;
	    g.fillRect (border, y, inWidth, pointerY - y) ; 
	}
	pointerY = y ;

	int ival = inHeight - (pointerY - border) ;
	value = (maxvalue - minvalue) * (double)ival / (double)inHeight + minvalue ;
    }
    public void mouseMoved (MouseEvent e) {
    }
}
